<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRelocationSeatDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRelocationSeatDetails
 * @subpackage Arrays
 */
class ArrayOfRelocationSeatDetails extends AbstractStructArrayBase
{
    /**
     * The RelocationSeatDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\RelocationSeatDetails[]
     */
    public $RelocationSeatDetails;
    /**
     * Constructor method for ArrayOfRelocationSeatDetails
     * @uses ArrayOfRelocationSeatDetails::setRelocationSeatDetails()
     * @param \patest\StructType\RelocationSeatDetails[] $relocationSeatDetails
     */
    public function __construct(array $relocationSeatDetails = array())
    {
        $this
            ->setRelocationSeatDetails($relocationSeatDetails);
    }
    /**
     * Get RelocationSeatDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\RelocationSeatDetails[]|null
     */
    public function getRelocationSeatDetails()
    {
        return isset($this->RelocationSeatDetails) ? $this->RelocationSeatDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRelocationSeatDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRelocationSeatDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRelocationSeatDetailsForArrayConstraintsFromSetRelocationSeatDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRelocationSeatDetailsRelocationSeatDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfRelocationSeatDetailsRelocationSeatDetailsItem instanceof \patest\StructType\RelocationSeatDetails) {
                $invalidValues[] = is_object($arrayOfRelocationSeatDetailsRelocationSeatDetailsItem) ? get_class($arrayOfRelocationSeatDetailsRelocationSeatDetailsItem) : sprintf('%s(%s)', gettype($arrayOfRelocationSeatDetailsRelocationSeatDetailsItem), var_export($arrayOfRelocationSeatDetailsRelocationSeatDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RelocationSeatDetails property can only contain items of type \patest\StructType\RelocationSeatDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RelocationSeatDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\RelocationSeatDetails[] $relocationSeatDetails
     * @return \patest\ArrayType\ArrayOfRelocationSeatDetails
     */
    public function setRelocationSeatDetails(array $relocationSeatDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($relocationSeatDetailsArrayErrorMessage = self::validateRelocationSeatDetailsForArrayConstraintsFromSetRelocationSeatDetails($relocationSeatDetails))) {
            throw new \InvalidArgumentException($relocationSeatDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($relocationSeatDetails) || (is_array($relocationSeatDetails) && empty($relocationSeatDetails))) {
            unset($this->RelocationSeatDetails);
        } else {
            $this->RelocationSeatDetails = $relocationSeatDetails;
        }
        return $this;
    }
    /**
     * Add item to RelocationSeatDetails value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\RelocationSeatDetails $item
     * @return \patest\ArrayType\ArrayOfRelocationSeatDetails
     */
    public function addToRelocationSeatDetails(\patest\StructType\RelocationSeatDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\RelocationSeatDetails) {
            throw new \InvalidArgumentException(sprintf('The RelocationSeatDetails property can only contain items of type \patest\StructType\RelocationSeatDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RelocationSeatDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\RelocationSeatDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\RelocationSeatDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\RelocationSeatDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\RelocationSeatDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\RelocationSeatDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RelocationSeatDetails
     */
    public function getAttributeName()
    {
        return 'RelocationSeatDetails';
    }
}
